

# Actions
<a name="API_Operations"></a>

The following actions are supported:
+  [CancelFlowExecutions](API_CancelFlowExecutions.md) 
+  [CreateConnectorProfile](API_CreateConnectorProfile.md) 
+  [CreateFlow](API_CreateFlow.md) 
+  [DeleteConnectorProfile](API_DeleteConnectorProfile.md) 
+  [DeleteFlow](API_DeleteFlow.md) 
+  [DescribeConnector](API_DescribeConnector.md) 
+  [DescribeConnectorEntity](API_DescribeConnectorEntity.md) 
+  [DescribeConnectorProfiles](API_DescribeConnectorProfiles.md) 
+  [DescribeConnectors](API_DescribeConnectors.md) 
+  [DescribeFlow](API_DescribeFlow.md) 
+  [DescribeFlowExecutionRecords](API_DescribeFlowExecutionRecords.md) 
+  [ListConnectorEntities](API_ListConnectorEntities.md) 
+  [ListConnectors](API_ListConnectors.md) 
+  [ListFlows](API_ListFlows.md) 
+  [ListTagsForResource](API_ListTagsForResource.md) 
+  [RegisterConnector](API_RegisterConnector.md) 
+  [ResetConnectorMetadataCache](API_ResetConnectorMetadataCache.md) 
+  [StartFlow](API_StartFlow.md) 
+  [StopFlow](API_StopFlow.md) 
+  [TagResource](API_TagResource.md) 
+  [UnregisterConnector](API_UnregisterConnector.md) 
+  [UntagResource](API_UntagResource.md) 
+  [UpdateConnectorProfile](API_UpdateConnectorProfile.md) 
+  [UpdateConnectorRegistration](API_UpdateConnectorRegistration.md) 
+  [UpdateFlow](API_UpdateFlow.md) 

# CancelFlowExecutions
<a name="API_CancelFlowExecutions"></a>

Cancels active runs for a flow.

You can cancel all of the active runs for a flow, or you can cancel specific runs by providing their IDs.

You can cancel a flow run only when the run is in progress. You can't cancel a run that has already completed or failed. You also can't cancel a run that's scheduled to occur but hasn't started yet. To prevent a scheduled run, you can deactivate the flow with the `StopFlow` action.

You cannot resume a run after you cancel it.

When you send your request, the status for each run becomes `CancelStarted`. When the cancellation completes, the status becomes `Canceled`.

**Note**  
When you cancel a run, you still incur charges for any data that the run already processed before the cancellation. If the run had already written some data to the flow destination, then that data remains in the destination. If you configured the flow to use a batch API (such as the Salesforce Bulk API 2.0), then the run will finish reading or writing its entire batch of data after the cancellation. For these operations, the data processing charges for Amazon AppFlow apply. For the pricing information, see [Amazon AppFlow pricing](http://aws.amazon.com/appflow/pricing/).

## Request Syntax
<a name="API_CancelFlowExecutions_RequestSyntax"></a>

```
POST /cancel-flow-executions HTTP/1.1
Content-type: application/json

{
   "executionIds": [ "string" ],
   "flowName": "string"
}
```

## URI Request Parameters
<a name="API_CancelFlowExecutions_RequestParameters"></a>

The request does not use any URI parameters.

## Request Body
<a name="API_CancelFlowExecutions_RequestBody"></a>

The request accepts the following data in JSON format.

 ** [executionIds](#API_CancelFlowExecutions_RequestSyntax) **   <a name="appflow-CancelFlowExecutions-request-executionIds"></a>
The ID of each active run to cancel. These runs must belong to the flow you specify in your request.  
If you omit this parameter, your request ends all active runs that belong to the flow.  
Type: Array of strings  
Array Members: Minimum number of 0 items. Maximum number of 100 items.  
Length Constraints: Maximum length of 256.  
Pattern: `\S+`   
Required: No

 ** [flowName](#API_CancelFlowExecutions_RequestSyntax) **   <a name="appflow-CancelFlowExecutions-request-flowName"></a>
The name of a flow with active runs that you want to cancel.  
Type: String  
Length Constraints: Maximum length of 256.  
Pattern: `[a-zA-Z0-9][\w!@#.-]+`   
Required: Yes

## Response Syntax
<a name="API_CancelFlowExecutions_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "invalidExecutions": [ "string" ]
}
```

## Response Elements
<a name="API_CancelFlowExecutions_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [invalidExecutions](#API_CancelFlowExecutions_ResponseSyntax) **   <a name="appflow-CancelFlowExecutions-response-invalidExecutions"></a>
The IDs of runs that Amazon AppFlow couldn't cancel. These runs might be ineligible for canceling because they haven't started yet or have already completed.  
Type: Array of strings  
Array Members: Minimum number of 0 items. Maximum number of 100 items.  
Length Constraints: Maximum length of 256.  
Pattern: `\S+` 

## Errors
<a name="API_CancelFlowExecutions_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
AppFlow/Requester has invalid or missing permissions.  
HTTP Status Code: 403

 ** InternalServerException **   
 An internal service error occurred during the processing of your request. Try again later.   
HTTP Status Code: 500

 ** ResourceNotFoundException **   
 The resource specified in the request (such as the source or destination connector profile) is not found.   
HTTP Status Code: 404

 ** ThrottlingException **   
API calls have exceeded the maximum allowed API request rate per account and per Region.   
HTTP Status Code: 429

 ** ValidationException **   
 The request has invalid or missing parameters.   
HTTP Status Code: 400

## See Also
<a name="API_CancelFlowExecutions_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/appflow-2020-08-23/CancelFlowExecutions) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/appflow-2020-08-23/CancelFlowExecutions) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/appflow-2020-08-23/CancelFlowExecutions) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/appflow-2020-08-23/CancelFlowExecutions) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/appflow-2020-08-23/CancelFlowExecutions) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/appflow-2020-08-23/CancelFlowExecutions) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/appflow-2020-08-23/CancelFlowExecutions) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/appflow-2020-08-23/CancelFlowExecutions) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/appflow-2020-08-23/CancelFlowExecutions) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/appflow-2020-08-23/CancelFlowExecutions) 

# CreateConnectorProfile
<a name="API_CreateConnectorProfile"></a>

 Creates a new connector profile associated with your AWS account. There is a soft quota of 100 connector profiles per AWS account. If you need more connector profiles than this quota allows, you can submit a request to the Amazon AppFlow team through the Amazon AppFlow support channel. In each connector profile that you create, you can provide the credentials and properties for only one connector.

## Request Syntax
<a name="API_CreateConnectorProfile_RequestSyntax"></a>

```
POST /create-connector-profile HTTP/1.1
Content-type: application/json

{
   "clientToken": "string",
   "connectionMode": "string",
   "connectorLabel": "string",
   "connectorProfileConfig": { 
      "connectorProfileCredentials": { 
         "Amplitude": { 
            "apiKey": "string",
            "secretKey": "string"
         },
         "CustomConnector": { 
            "apiKey": { 
               "apiKey": "string",
               "apiSecretKey": "string"
            },
            "authenticationType": "string",
            "basic": { 
               "password": "string",
               "username": "string"
            },
            "custom": { 
               "credentialsMap": { 
                  "string" : "string" 
               },
               "customAuthenticationType": "string"
            },
            "oauth2": { 
               "accessToken": "string",
               "clientId": "string",
               "clientSecret": "string",
               "oAuthRequest": { 
                  "authCode": "string",
                  "redirectUri": "string"
               },
               "refreshToken": "string"
            }
         },
         "Datadog": { 
            "apiKey": "string",
            "applicationKey": "string"
         },
         "Dynatrace": { 
            "apiToken": "string"
         },
         "GoogleAnalytics": { 
            "accessToken": "string",
            "clientId": "string",
            "clientSecret": "string",
            "oAuthRequest": { 
               "authCode": "string",
               "redirectUri": "string"
            },
            "refreshToken": "string"
         },
         "Honeycode": { 
            "accessToken": "string",
            "oAuthRequest": { 
               "authCode": "string",
               "redirectUri": "string"
            },
            "refreshToken": "string"
         },
         "InforNexus": { 
            "accessKeyId": "string",
            "datakey": "string",
            "secretAccessKey": "string",
            "userId": "string"
         },
         "Marketo": { 
            "accessToken": "string",
            "clientId": "string",
            "clientSecret": "string",
            "oAuthRequest": { 
               "authCode": "string",
               "redirectUri": "string"
            }
         },
         "Pardot": { 
            "accessToken": "string",
            "clientCredentialsArn": "string",
            "oAuthRequest": { 
               "authCode": "string",
               "redirectUri": "string"
            },
            "refreshToken": "string"
         },
         "Redshift": { 
            "password": "string",
            "username": "string"
         },
         "Salesforce": { 
            "accessToken": "string",
            "clientCredentialsArn": "string",
            "jwtToken": "string",
            "oAuth2GrantType": "string",
            "oAuthRequest": { 
               "authCode": "string",
               "redirectUri": "string"
            },
            "refreshToken": "string"
         },
         "SAPOData": { 
            "basicAuthCredentials": { 
               "password": "string",
               "username": "string"
            },
            "oAuthCredentials": { 
               "accessToken": "string",
               "clientId": "string",
               "clientSecret": "string",
               "oAuthRequest": { 
                  "authCode": "string",
                  "redirectUri": "string"
               },
               "refreshToken": "string"
            }
         },
         "ServiceNow": { 
            "oAuth2Credentials": { 
               "accessToken": "string",
               "clientId": "string",
               "clientSecret": "string",
               "oAuthRequest": { 
                  "authCode": "string",
                  "redirectUri": "string"
               },
               "refreshToken": "string"
            },
            "password": "string",
            "username": "string"
         },
         "Singular": { 
            "apiKey": "string"
         },
         "Slack": { 
            "accessToken": "string",
            "clientId": "string",
            "clientSecret": "string",
            "oAuthRequest": { 
               "authCode": "string",
               "redirectUri": "string"
            }
         },
         "Snowflake": { 
            "password": "string",
            "username": "string"
         },
         "Trendmicro": { 
            "apiSecretKey": "string"
         },
         "Veeva": { 
            "password": "string",
            "username": "string"
         },
         "Zendesk": { 
            "accessToken": "string",
            "clientId": "string",
            "clientSecret": "string",
            "oAuthRequest": { 
               "authCode": "string",
               "redirectUri": "string"
            }
         }
      },
      "connectorProfileProperties": { 
         "Amplitude": { 
         },
         "CustomConnector": { 
            "oAuth2Properties": { 
               "oAuth2GrantType": "string",
               "tokenUrl": "string",
               "tokenUrlCustomProperties": { 
                  "string" : "string" 
               }
            },
            "profileProperties": { 
               "string" : "string" 
            }
         },
         "Datadog": { 
            "instanceUrl": "string"
         },
         "Dynatrace": { 
            "instanceUrl": "string"
         },
         "GoogleAnalytics": { 
         },
         "Honeycode": { 
         },
         "InforNexus": { 
            "instanceUrl": "string"
         },
         "Marketo": { 
            "instanceUrl": "string"
         },
         "Pardot": { 
            "businessUnitId": "string",
            "instanceUrl": "string",
            "isSandboxEnvironment": boolean
         },
         "Redshift": { 
            "bucketName": "string",
            "bucketPrefix": "string",
            "clusterIdentifier": "string",
            "dataApiRoleArn": "string",
            "databaseName": "string",
            "databaseUrl": "string",
            "isRedshiftServerless": boolean,
            "roleArn": "string",
            "workgroupName": "string"
         },
         "Salesforce": { 
            "instanceUrl": "string",
            "isSandboxEnvironment": boolean,
            "usePrivateLinkForMetadataAndAuthorization": boolean
         },
         "SAPOData": { 
            "applicationHostUrl": "string",
            "applicationServicePath": "string",
            "clientNumber": "string",
            "disableSSO": boolean,
            "logonLanguage": "string",
            "oAuthProperties": { 
               "authCodeUrl": "string",
               "oAuthScopes": [ "string" ],
               "tokenUrl": "string"
            },
            "portNumber": number,
            "privateLinkServiceName": "string"
         },
         "ServiceNow": { 
            "instanceUrl": "string"
         },
         "Singular": { 
         },
         "Slack": { 
            "instanceUrl": "string"
         },
         "Snowflake": { 
            "accountName": "string",
            "bucketName": "string",
            "bucketPrefix": "string",
            "privateLinkServiceName": "string",
            "region": "string",
            "stage": "string",
            "warehouse": "string"
         },
         "Trendmicro": { 
         },
         "Veeva": { 
            "instanceUrl": "string"
         },
         "Zendesk": { 
            "instanceUrl": "string"
         }
      }
   },
   "connectorProfileName": "string",
   "connectorType": "string",
   "kmsArn": "string"
}
```

## URI Request Parameters
<a name="API_CreateConnectorProfile_RequestParameters"></a>

The request does not use any URI parameters.

## Request Body
<a name="API_CreateConnectorProfile_RequestBody"></a>

The request accepts the following data in JSON format.

 ** [clientToken](#API_CreateConnectorProfile_RequestSyntax) **   <a name="appflow-CreateConnectorProfile-request-clientToken"></a>
The `clientToken` parameter is an idempotency token. It ensures that your `CreateConnectorProfile` request completes only once. You choose the value to pass. For example, if you don't receive a response from your request, you can safely retry the request with the same `clientToken` parameter value.  
If you omit a `clientToken` value, the AWS SDK that you are using inserts a value for you. This way, the SDK can safely retry requests multiple times after a network error. You must provide your own value for other use cases.  
If you specify input parameters that differ from your first request, an error occurs. If you use a different value for `clientToken`, Amazon AppFlow considers it a new call to `CreateConnectorProfile`. The token is active for 8 hours.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 256.  
Pattern: `[ -~]+`   
Required: No

 ** [connectionMode](#API_CreateConnectorProfile_RequestSyntax) **   <a name="appflow-CreateConnectorProfile-request-connectionMode"></a>
 Indicates the connection mode and specifies whether it is public or private. Private flows use AWS PrivateLink to route data over AWS infrastructure without exposing it to the public internet.   
Type: String  
Valid Values: `Public | Private`   
Required: Yes

 ** [connectorLabel](#API_CreateConnectorProfile_RequestSyntax) **   <a name="appflow-CreateConnectorProfile-request-connectorLabel"></a>
The label of the connector. The label is unique for each `ConnectorRegistration` in your AWS account. Only needed if calling for CUSTOMCONNECTOR connector type/.  
Type: String  
Length Constraints: Maximum length of 256.  
Pattern: `[a-zA-Z0-9][\w!@#.-]+`   
Required: No

 ** [connectorProfileConfig](#API_CreateConnectorProfile_RequestSyntax) **   <a name="appflow-CreateConnectorProfile-request-connectorProfileConfig"></a>
 Defines the connector-specific configuration and credentials.   
Type: [ConnectorProfileConfig](API_ConnectorProfileConfig.md) object  
Required: Yes

 ** [connectorProfileName](#API_CreateConnectorProfile_RequestSyntax) **   <a name="appflow-CreateConnectorProfile-request-connectorProfileName"></a>
 The name of the connector profile. The name is unique for each `ConnectorProfile` in your AWS account.   
Type: String  
Length Constraints: Maximum length of 256.  
Pattern: `[\w/!@#+=.-]+`   
Required: Yes

 ** [connectorType](#API_CreateConnectorProfile_RequestSyntax) **   <a name="appflow-CreateConnectorProfile-request-connectorType"></a>
 The type of connector, such as Salesforce, Amplitude, and so on.   
Type: String  
Valid Values: `Salesforce | Singular | Slack | Redshift | S3 | Marketo | Googleanalytics | Zendesk | Servicenow | Datadog | Trendmicro | Snowflake | Dynatrace | Infornexus | Amplitude | Veeva | EventBridge | LookoutMetrics | Upsolver | Honeycode | CustomerProfiles | SAPOData | CustomConnector | Pardot`   
Required: Yes

 ** [kmsArn](#API_CreateConnectorProfile_RequestSyntax) **   <a name="appflow-CreateConnectorProfile-request-kmsArn"></a>
 The ARN (Amazon Resource Name) of the Key Management Service (KMS) key you provide for encryption. This is required if you do not want to use the Amazon AppFlow-managed KMS key. If you don't provide anything here, Amazon AppFlow uses the Amazon AppFlow-managed KMS key.   
Type: String  
Length Constraints: Minimum length of 20. Maximum length of 2048.  
Pattern: `arn:aws:kms:.*:[0-9]+:.*`   
Required: No

## Response Syntax
<a name="API_CreateConnectorProfile_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "connectorProfileArn": "string"
}
```

## Response Elements
<a name="API_CreateConnectorProfile_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [connectorProfileArn](#API_CreateConnectorProfile_ResponseSyntax) **   <a name="appflow-CreateConnectorProfile-response-connectorProfileArn"></a>
 The Amazon Resource Name (ARN) of the connector profile.   
Type: String  
Length Constraints: Maximum length of 512.  
Pattern: `arn:aws:appflow:.*:[0-9]+:.*` 

## Errors
<a name="API_CreateConnectorProfile_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** ConflictException **   
 There was a conflict when processing the request (for example, a flow with the given name already exists within the account. Check for conflicting resource names and try again.   
HTTP Status Code: 409

 ** ConnectorAuthenticationException **   
 An error occurred when authenticating with the connector endpoint.   
HTTP Status Code: 401

 ** InternalServerException **   
 An internal service error occurred during the processing of your request. Try again later.   
HTTP Status Code: 500

 ** ServiceQuotaExceededException **   
 The request would cause a service quota (such as the number of flows) to be exceeded.   
HTTP Status Code: 402

 ** ValidationException **   
 The request has invalid or missing parameters.   
HTTP Status Code: 400

## Examples
<a name="API_CreateConnectorProfile_Examples"></a>

### CustomConnector
<a name="API_CreateConnectorProfile_Example_1"></a>

This example shows a sample request for the `CreateConnectorProfile` API (without OAuth) and a sample response.

#### Sample Request
<a name="API_CreateConnectorProfile_Example_1_Request"></a>

```
{
  "connectorProfileName": "Connector_Profile_Name_Value",
  "kmsArn": null,
  "connectorType": "CUSTOMCONNECTOR",
  "connectorLabel": "MyCustomConnector",
  "connectionMode": "Public",
  "connectorProfileConfig":
  {
    "connectorProfileProperties":
    {
      "salesforce":
      {
        "instanceUrl": "InstanceUrl_value",
        "isSandboxEnvironment": false
      }
    },
    "connectorProfileCredentials":
    {
      "salesforce":
      {
        "accessToken": "<AccessToken>",
        "refreshToken": "<RefreshToken>",
        "oauthRequest":
        {
          "authCode": null,
          "redirectUri": null
        }
      }
    }
  }
}
```

#### Sample Response
<a name="API_CreateConnectorProfile_Example_1_Response"></a>

```
{
  "connectorProfileArn": "arn:aws:appflow:region:<AccountId>:connectorprofile/Connector_Profile_Name"
}
```

### Salesforce without OAuth
<a name="API_CreateConnectorProfile_Example_2"></a>

This example shows a sample request for the `CreateConnectorProfile` API (without OAuth) and a sample response.

#### Sample Request
<a name="API_CreateConnectorProfile_Example_2_Request"></a>

```
{
  "connectorProfileName": "Connector_Profile_Name_Value",
  "kmsArn": null,
  "connectorType": "Salesforce",
  "connectorLabel": "Salesforce",
  "connectionMode": "Public",
  "connectorProfileConfig": {
    "connectorProfileProperties": {
      "salesforce": {
        "instanceUrl": "InstanceUrl_value",
        "isSandboxEnvironment": false
      }
    },
    "connectorProfileCredentials": {
      "salesforce": {
        "accessToken": "<AccessToken>",
        "refreshToken": "<RefreshToken>",
        "oauthRequest": {
          "authCode": null,
          "redirectUri": null
        }
      }
    }
  }
}
```

#### Sample Response
<a name="API_CreateConnectorProfile_Example_2_Response"></a>

```
{
  "connectorProfileArn": "arn:aws:appflow:region:<AccountId>:connectorprofile/Connector_Profile_Name"
}
```

### Salesforce with OAuth
<a name="API_CreateConnectorProfile_Example_3"></a>

These examples show a request with OAuth and a sample response.

#### Sample Request
<a name="API_CreateConnectorProfile_Example_3_Request"></a>

```
{
  "connectorProfileName": "connector-profile-name_value",
  "kmsArn": null,
  "connectorType": "Salesforce",
  "connectionMode": "Public",
  "connectorProfileConfig": {
    "connectorProfileProperties": {
      "salesforce": {
        "isSandboxEnvironment": false
      }
    },
    "connectorProfileCredentials": {
      "salesforce": {
        "oauthRequest": {
          "authCode": "<AuthCode>",
          "redirectUri": "redirectUri"
        }
      }
    }
  }
}
```

#### Sample Response
<a name="API_CreateConnectorProfile_Example_3_Response"></a>

```
{
  "connectorProfileArn": "arn:aws:appflow:region:<AccountId>:connectorprofile/connector-profile-name"
}
```

### Zendesk
<a name="API_CreateConnectorProfile_Example_4"></a>

This example shows a sample request and response for the `CreateConnectorProfile` API using Zendesk.

#### Sample Request
<a name="API_CreateConnectorProfile_Example_4_Request"></a>

```
{
  "connectorProfileName": "connector-profile-name",
  "connectorType": "Zendesk",
  "connectionMode": "Public",
  "connectorProfileConfig": {
    "connectorProfileProperties": {
      "zendesk": {
        "instanceUrl": "Zendesk_Url"
      }
    },
    "connectorProfileCredentials": {
      "zendesk": {
        "clientId": "aws_integration_to_zendesk",
        "clientSecret": "<ClientSecret>",
        "accessToken": "<AccessToken>",
        "oauthRequest": {
          "authCode": null,
          "redirectUri": null
        }
      }
    }
  }
}
```

#### Sample Response
<a name="API_CreateConnectorProfile_Example_4_Response"></a>

```
{
  "connectorProfileArn": "arn:aws:appflow:region:<AccountId>:connectorprofile/connector-profile-name"
}
```

### Google Analytics
<a name="API_CreateConnectorProfile_Example_5"></a>

This example shows a sample request and response for the `CreateConnectorProfile` API using Google Analytics.

#### Sample Request
<a name="API_CreateConnectorProfile_Example_5_Request"></a>

```
{
  "connectorProfileName": "connector-profile-name",
  "connectorType": "Googleanalytics",
  "connectionMode": "Public",
  "connectorProfileConfig": {
    "connectorProfileProperties": {
      "googleAnalytics": {}
    },
    "connectorProfileCredentials": {
      "googleAnalytics": {
        "clientId": "<ClientId>",
        "clientSecret": "<ClientSecret>",
        "accessToken": "<AccessToken>",
        "refreshToken": "<RefreshToken>",
        "oauthRequest": {
          "authCode": null,
          "redirectUri": null
        }
      }
    }
  }
}
```

```
{
  "connectorProfileArn": "arn:aws:appflow:region:<AccountId>:connectorprofile/connector-profile-name"
}
```

### Marketo
<a name="API_CreateConnectorProfile_Example_6"></a>

This example shows a sample request and response for the `CreateConnectorProfile` API using Marketo.

#### Sample Request
<a name="API_CreateConnectorProfile_Example_6_Request"></a>

```
{
  "connectorProfileName": "Connector-profile-new",
  "connectorType": "Marketo",
  "connectionMode": "Public",
  "connectorProfileConfig": {
    "connectorProfileProperties": {
      "marketo": {
        "instanceUrl": "Marketo_Url"
      }
    },
    "connectorProfileCredentials": {
      "marketo": {
        "clientId": "<ClientId>>",
        "clientSecret": "<ClientSecret>",
        "accessToken": "<AccessToken>",
        "oauthRequest": {
          "authCode": null,
          "redirectUri": null
        }
      }
    }
  }
}
```

#### Sample Response
<a name="API_CreateConnectorProfile_Example_6_Response"></a>

```
{
  "connectorProfileArn": "arn:aws:appflow:region:<AccountId>:connectorprofile/Connector-profile-new"
}
```

## See Also
<a name="API_CreateConnectorProfile_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/appflow-2020-08-23/CreateConnectorProfile) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/appflow-2020-08-23/CreateConnectorProfile) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/appflow-2020-08-23/CreateConnectorProfile) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/appflow-2020-08-23/CreateConnectorProfile) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/appflow-2020-08-23/CreateConnectorProfile) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/appflow-2020-08-23/CreateConnectorProfile) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/appflow-2020-08-23/CreateConnectorProfile) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/appflow-2020-08-23/CreateConnectorProfile) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/appflow-2020-08-23/CreateConnectorProfile) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/appflow-2020-08-23/CreateConnectorProfile) 

# CreateFlow
<a name="API_CreateFlow"></a>

 Enables your application to create a new flow using Amazon AppFlow. You must create a connector profile before calling this API. Please note that the Request Syntax below shows syntax for multiple destinations, however, you can only transfer data to one item in this list at a time. Amazon AppFlow does not currently support flows to multiple destinations at once. 

## Request Syntax
<a name="API_CreateFlow_RequestSyntax"></a>

```
POST /create-flow HTTP/1.1
Content-type: application/json

{
   "clientToken": "string",
   "description": "string",
   "destinationFlowConfigList": [ 
      { 
         "apiVersion": "string",
         "connectorProfileName": "string",
         "connectorType": "string",
         "destinationConnectorProperties": { 
            "CustomConnector": { 
               "customProperties": { 
                  "string" : "string" 
               },
               "entityName": "string",
               "errorHandlingConfig": { 
                  "bucketName": "string",
                  "bucketPrefix": "string",
                  "failOnFirstDestinationError": boolean
               },
               "idFieldNames": [ "string" ],
               "writeOperationType": "string"
            },
            "CustomerProfiles": { 
               "domainName": "string",
               "objectTypeName": "string"
            },
            "EventBridge": { 
               "errorHandlingConfig": { 
                  "bucketName": "string",
                  "bucketPrefix": "string",
                  "failOnFirstDestinationError": boolean
               },
               "object": "string"
            },
            "Honeycode": { 
               "errorHandlingConfig": { 
                  "bucketName": "string",
                  "bucketPrefix": "string",
                  "failOnFirstDestinationError": boolean
               },
               "object": "string"
            },
            "LookoutMetrics": { 
            },
            "Marketo": { 
               "errorHandlingConfig": { 
                  "bucketName": "string",
                  "bucketPrefix": "string",
                  "failOnFirstDestinationError": boolean
               },
               "object": "string"
            },
            "Redshift": { 
               "bucketPrefix": "string",
               "errorHandlingConfig": { 
                  "bucketName": "string",
                  "bucketPrefix": "string",
                  "failOnFirstDestinationError": boolean
               },
               "intermediateBucketName": "string",
               "object": "string"
            },
            "S3": { 
               "bucketName": "string",
               "bucketPrefix": "string",
               "s3OutputFormatConfig": { 
                  "aggregationConfig": { 
                     "aggregationType": "string",
                     "targetFileSize": number
                  },
                  "fileType": "string",
                  "prefixConfig": { 
                     "pathPrefixHierarchy": [ "string" ],
                     "prefixFormat": "string",
                     "prefixType": "string"
                  },
                  "preserveSourceDataTyping": boolean
               }
            },
            "Salesforce": { 
               "dataTransferApi": "string",
               "errorHandlingConfig": { 
                  "bucketName": "string",
                  "bucketPrefix": "string",
                  "failOnFirstDestinationError": boolean
               },
               "idFieldNames": [ "string" ],
               "object": "string",
               "writeOperationType": "string"
            },
            "SAPOData": { 
               "errorHandlingConfig": { 
                  "bucketName": "string",
                  "bucketPrefix": "string",
                  "failOnFirstDestinationError": boolean
               },
               "idFieldNames": [ "string" ],
               "objectPath": "string",
               "successResponseHandlingConfig": { 
                  "bucketName": "string",
                  "bucketPrefix": "string"
               },
               "writeOperationType": "string"
            },
            "Snowflake": { 
               "bucketPrefix": "string",
               "errorHandlingConfig": { 
                  "bucketName": "string",
                  "bucketPrefix": "string",
                  "failOnFirstDestinationError": boolean
               },
               "intermediateBucketName": "string",
               "object": "string"
            },
            "Upsolver": { 
               "bucketName": "string",
               "bucketPrefix": "string",
               "s3OutputFormatConfig": { 
                  "aggregationConfig": { 
                     "aggregationType": "string",
                     "targetFileSize": number
                  },
                  "fileType": "string",
                  "prefixConfig": { 
                     "pathPrefixHierarchy": [ "string" ],
                     "prefixFormat": "string",
                     "prefixType": "string"
                  }
               }
            },
            "Zendesk": { 
               "errorHandlingConfig": { 
                  "bucketName": "string",
                  "bucketPrefix": "string",
                  "failOnFirstDestinationError": boolean
               },
               "idFieldNames": [ "string" ],
               "object": "string",
               "writeOperationType": "string"
            }
         }
      }
   ],
   "flowName": "string",
   "kmsArn": "string",
   "metadataCatalogConfig": { 
      "glueDataCatalog": { 
         "databaseName": "string",
         "roleArn": "string",
         "tablePrefix": "string"
      }
   },
   "sourceFlowConfig": { 
      "apiVersion": "string",
      "connectorProfileName": "string",
      "connectorType": "string",
      "incrementalPullConfig": { 
         "datetimeTypeFieldName": "string"
      },
      "sourceConnectorProperties": { 
         "Amplitude": { 
            "object": "string"
         },
         "CustomConnector": { 
            "customProperties": { 
               "string" : "string" 
            },
            "dataTransferApi": { 
               "Name": "string",
               "Type": "string"
            },
            "entityName": "string"
         },
         "Datadog": { 
            "object": "string"
         },
         "Dynatrace": { 
            "object": "string"
         },
         "GoogleAnalytics": { 
            "object": "string"
         },
         "InforNexus": { 
            "object": "string"
         },
         "Marketo": { 
            "object": "string"
         },
         "Pardot": { 
            "object": "string"
         },
         "S3": { 
            "bucketName": "string",
            "bucketPrefix": "string",
            "s3InputFormatConfig": { 
               "s3InputFileType": "string"
            }
         },
         "Salesforce": { 
            "dataTransferApi": "string",
            "enableDynamicFieldUpdate": boolean,
            "includeDeletedRecords": boolean,
            "object": "string"
         },
         "SAPOData": { 
            "objectPath": "string",
            "paginationConfig": { 
               "maxPageSize": number
            },
            "parallelismConfig": { 
               "maxParallelism": number
            }
         },
         "ServiceNow": { 
            "object": "string"
         },
         "Singular": { 
            "object": "string"
         },
         "Slack": { 
            "object": "string"
         },
         "Trendmicro": { 
            "object": "string"
         },
         "Veeva": { 
            "documentType": "string",
            "includeAllVersions": boolean,
            "includeRenditions": boolean,
            "includeSourceFiles": boolean,
            "object": "string"
         },
         "Zendesk": { 
            "object": "string"
         }
      }
   },
   "tags": { 
      "string" : "string" 
   },
   "tasks": [ 
      { 
         "connectorOperator": { 
            "Amplitude": "string",
            "CustomConnector": "string",
            "Datadog": "string",
            "Dynatrace": "string",
            "GoogleAnalytics": "string",
            "InforNexus": "string",
            "Marketo": "string",
            "Pardot": "string",
            "S3": "string",
            "Salesforce": "string",
            "SAPOData": "string",
            "ServiceNow": "string",
            "Singular": "string",
            "Slack": "string",
            "Trendmicro": "string",
            "Veeva": "string",
            "Zendesk": "string"
         },
         "destinationField": "string",
         "sourceFields": [ "string" ],
         "taskProperties": { 
            "string" : "string" 
         },
         "taskType": "string"
      }
   ],
   "triggerConfig": { 
      "triggerProperties": { 
         "Scheduled": { 
            "dataPullMode": "string",
            "firstExecutionFrom": number,
            "flowErrorDeactivationThreshold": number,
            "scheduleEndTime": number,
            "scheduleExpression": "string",
            "scheduleOffset": number,
            "scheduleStartTime": number,
            "timezone": "string"
         }
      },
      "triggerType": "string"
   }
}
```

## URI Request Parameters
<a name="API_CreateFlow_RequestParameters"></a>

The request does not use any URI parameters.

## Request Body
<a name="API_CreateFlow_RequestBody"></a>

The request accepts the following data in JSON format.

 ** [clientToken](#API_CreateFlow_RequestSyntax) **   <a name="appflow-CreateFlow-request-clientToken"></a>
The `clientToken` parameter is an idempotency token. It ensures that your `CreateFlow` request completes only once. You choose the value to pass. For example, if you don't receive a response from your request, you can safely retry the request with the same `clientToken` parameter value.  
If you omit a `clientToken` value, the AWS SDK that you are using inserts a value for you. This way, the SDK can safely retry requests multiple times after a network error. You must provide your own value for other use cases.  
If you specify input parameters that differ from your first request, an error occurs. If you use a different value for `clientToken`, Amazon AppFlow considers it a new call to `CreateFlow`. The token is active for 8 hours.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 256.  
Pattern: `[ -~]+`   
Required: No

 ** [description](#API_CreateFlow_RequestSyntax) **   <a name="appflow-CreateFlow-request-description"></a>
 A description of the flow you want to create.   
Type: String  
Length Constraints: Maximum length of 2048.  
Pattern: `[\w!@#\-.?,\s]*`   
Required: No

 ** [destinationFlowConfigList](#API_CreateFlow_RequestSyntax) **   <a name="appflow-CreateFlow-request-destinationFlowConfigList"></a>
 The configuration that controls how Amazon AppFlow places data in the destination connector.   
Type: Array of [DestinationFlowConfig](API_DestinationFlowConfig.md) objects  
Required: Yes

 ** [flowName](#API_CreateFlow_RequestSyntax) **   <a name="appflow-CreateFlow-request-flowName"></a>
 The specified name of the flow. Spaces are not allowed. Use underscores (\$1) or hyphens (-) only.   
Type: String  
Length Constraints: Maximum length of 256.  
Pattern: `[a-zA-Z0-9][\w!@#.-]+`   
Required: Yes

 ** [kmsArn](#API_CreateFlow_RequestSyntax) **   <a name="appflow-CreateFlow-request-kmsArn"></a>
 The ARN (Amazon Resource Name) of the Key Management Service (KMS) key you provide for encryption. This is required if you do not want to use the Amazon AppFlow-managed KMS key. If you don't provide anything here, Amazon AppFlow uses the Amazon AppFlow-managed KMS key.   
Type: String  
Length Constraints: Minimum length of 20. Maximum length of 2048.  
Pattern: `arn:aws:kms:.*:[0-9]+:.*`   
Required: No

 ** [metadataCatalogConfig](#API_CreateFlow_RequestSyntax) **   <a name="appflow-CreateFlow-request-metadataCatalogConfig"></a>
Specifies the configuration that Amazon AppFlow uses when it catalogs the data that's transferred by the associated flow. When Amazon AppFlow catalogs the data from a flow, it stores metadata in a data catalog.  
Type: [MetadataCatalogConfig](API_MetadataCatalogConfig.md) object  
Required: No

 ** [sourceFlowConfig](#API_CreateFlow_RequestSyntax) **   <a name="appflow-CreateFlow-request-sourceFlowConfig"></a>
 The configuration that controls how Amazon AppFlow retrieves data from the source connector.   
Type: [SourceFlowConfig](API_SourceFlowConfig.md) object  
Required: Yes

 ** [tags](#API_CreateFlow_RequestSyntax) **   <a name="appflow-CreateFlow-request-tags"></a>
 The tags used to organize, track, or control access for your flow.   
Type: String to string map  
Map Entries: Minimum number of 0 items. Maximum number of 50 items.  
Key Length Constraints: Minimum length of 1. Maximum length of 128.  
Key Pattern: `^(?!aws:)[a-zA-Z+-=._:/]+$`   
Value Length Constraints: Maximum length of 256.  
Value Pattern: `[\s\w+-=\.:/@]*`   
Required: No

 ** [tasks](#API_CreateFlow_RequestSyntax) **   <a name="appflow-CreateFlow-request-tasks"></a>
 A list of tasks that Amazon AppFlow performs while transferring the data in the flow run.   
Type: Array of [Task](API_Task.md) objects  
Required: Yes

 ** [triggerConfig](#API_CreateFlow_RequestSyntax) **   <a name="appflow-CreateFlow-request-triggerConfig"></a>
 The trigger settings that determine how and when the flow runs.   
Type: [TriggerConfig](API_TriggerConfig.md) object  
Required: Yes

## Response Syntax
<a name="API_CreateFlow_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "flowArn": "string",
   "flowStatus": "string"
}
```

## Response Elements
<a name="API_CreateFlow_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [flowArn](#API_CreateFlow_ResponseSyntax) **   <a name="appflow-CreateFlow-response-flowArn"></a>
 The flow's Amazon Resource Name (ARN).   
Type: String  
Length Constraints: Maximum length of 512.  
Pattern: `arn:aws:appflow:.*:[0-9]+:.*` 

 ** [flowStatus](#API_CreateFlow_ResponseSyntax) **   <a name="appflow-CreateFlow-response-flowStatus"></a>
 Indicates the current status of the flow.   
Type: String  
Valid Values: `Active | Deprecated | Deleted | Draft | Errored | Suspended` 

## Errors
<a name="API_CreateFlow_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
AppFlow/Requester has invalid or missing permissions.  
HTTP Status Code: 403

 ** ConflictException **   
 There was a conflict when processing the request (for example, a flow with the given name already exists within the account. Check for conflicting resource names and try again.   
HTTP Status Code: 409

 ** ConnectorAuthenticationException **   
 An error occurred when authenticating with the connector endpoint.   
HTTP Status Code: 401

 ** ConnectorServerException **   
 An error occurred when retrieving data from the connector endpoint.   
HTTP Status Code: 400

 ** InternalServerException **   
 An internal service error occurred during the processing of your request. Try again later.   
HTTP Status Code: 500

 ** ResourceNotFoundException **   
 The resource specified in the request (such as the source or destination connector profile) is not found.   
HTTP Status Code: 404

 ** ServiceQuotaExceededException **   
 The request would cause a service quota (such as the number of flows) to be exceeded.   
HTTP Status Code: 402

 ** ValidationException **   
 The request has invalid or missing parameters.   
HTTP Status Code: 400

## Examples
<a name="API_CreateFlow_Examples"></a>

### Salesforce
<a name="API_CreateFlow_Example_1"></a>

This example shows a sample request for the `CreateFlow` API using Salesforce. If you see the error shown in the second sample, it is because of an expired access or refresh token. Retrieve a new access or refresh token to proceed.

#### Sample Request
<a name="API_CreateFlow_Example_1_Request"></a>

```
{
  "flowName": "testFlowSaleforce",
  "description": "TestFlow",
  "triggerConfig": {
    "triggerType": "Scheduled",
    "triggerProperties": {
        "scheduledTriggerProperties" : {
            "scheduleExpression" : "rate(1minutes)"
        }
    }
  },
  "sourceFlowConfig": {
    "connectorType": "Salesforce",
    "connectorLabel":"MyCustomConnector",
    "connectorProfileName": "Connector_Profile_Name",
    "sourceConnectorProperties": {
      "salesforce": {
         "object": "account"
      }
    }
  },
  "destinationFlowConfigList": [
    {
      "connectorType": "S3",
      "connectorLabel":"MyCustomConnector",
      "destinationConnectorProperties": {
        "s3": {
          "bucketName": "BucketName",
          "bucketKey": "BucketKey"
        }
      }
    }
  ],
  "tasks": [
    {
      "sourceFields": [
        "CreatedDate"
      ],
      "taskProperties": {
 
      },
      "destinationField": "CreatedDate",
      "taskType": "Map"
    },
    {
      "destinationField": "LastActivityDate",
      "sourceFields": [
        "LastActivityDate"
      ],
      "taskProperties": {

      },
      "taskType": "Map"
    }
  ]
}
```

```
{
  "message": "Error while authenticating to connector"
}
```

### Zendesk
<a name="API_CreateFlow_Example_2"></a>

This example shows a sample request for the `CreateFlow` API using Zendesk.

#### Sample Request
<a name="API_CreateFlow_Example_2_Request"></a>

```
{
  "useDefaultEncryption": false,
  "flowName": "testFlowZendesk",
  "description": "TestFlow",
  "triggerConfig": {
    "triggerType": "Scheduled",
    "triggerProperties": {
        "scheduledTriggerProperties" : {
            "scheduleExpression" : "rate(1minutes)"
        }
    }
  },
  "sourceFlowConfig": {
    "connectorType": "Zendesk",
    "connectorProfileName": "connector-profile-name",
    "sourceConnectorProperties": {
      "zendesk": {
         "object": "tickets"
      }
    }
  },
  "destinationFlowConfigList": [
    {
      "connectorType": "S3",
      "connectorProfileName": "Test",
      "destinationConnectorProperties": {
        "s3": {
          "bucketName": "BucketName",
          "bucketKey": "BucketKey"
        }
      }
    }
  ],
  "tasks": [
    {
      "destinationField": "url",
      "sourceFields": [
        "url"
      ],
      "taskProperties": {
          "SOURCE_DATA_TYPE": "integer"
      },
      "taskType": "Map"
    }
  ]
}
```

### Google Analytics
<a name="API_CreateFlow_Example_3"></a>

This example shows a sample request for the `CreateFlow` API using Google Analytics.

#### Sample Request
<a name="API_CreateFlow_Example_3_Request"></a>

```
 {
  "useDefaultEncryption": false,
  "flowName": "testFlowGAnalytics",
  "description": "TestFlow",
  "triggerConfig": {
    "triggerType": "Scheduled",
    "triggerProperties": {
        "scheduledTriggerProperties" : {
            "scheduleExpression" : "rate(1minutes)"
        }
    }
  },
  "sourceFlowConfig": {
    "connectorType": "Googleanalytics",
    "connectorProfileName": "connector-profile-name",
    "sourceConnectorProperties": {
      "googleanalytics": {
         "object": "ObjectID"
      }
    }
  },
  "destinationFlowConfigList": [
    {
      "connectorType": "S3",
      "connectorProfileName": "Test",
      "destinationConnectorProperties": {
        "s3": {
          "bucketName": "BucketName",
          "bucketKey": "BucketKey"
        }
      }
    }
  ],
  "tasks": [
    {
      "destinationField": "url",
      "sourceFields": [
        "url"
      ],
      "taskProperties": {
          "SOURCE_DATA_TYPE": "integer"
      },
      "taskType": "Map"
    }
  ]
}
```

### Marketo
<a name="API_CreateFlow_Example_4"></a>

This example shows a sample request for the `CreateFlow` API using Marketo.

#### Sample Request
<a name="API_CreateFlow_Example_4_Request"></a>

```
{
  "flowName": "testMarketo",
  "description": "TestFlow",
  "triggerConfig": {
    "triggerType": "Scheduled",
    "triggerProperties": {
        "scheduledTriggerProperties" : {
            "scheduleExpression" : "rate(1minutes)"
        }
    }
  },
  "sourceFlowConfig": {
    "connectorType": "Marketo",
    "connectorProfileName": "Connector-profile-new",
    "sourceConnectorProperties": {
      "marketo": {
         "object": "leads"
      }
    }
  },
  "destinationFlowConfigList": [
    {
      "connectorType": "S3",
      "connectorProfileName": "Test",
      "destinationConnectorProperties": {
        "s3": {
          "bucketName": "BucketName",
          "bucketKey": "BucketKey"
        }
      }
    }
  ],
  "tasks": [
      {
      "connectorOperator": {
          "marketo":"BETWEEN"
      },
      "sourceFields": [
        "updatedAt"
      ],
      "taskProperties": {
        "DATA_TYPE": "datetime",
        "LOWER_BOUND": "Lower_Bound_value",
        "UPPER_BOUND": "Upper_Bound_value"
      },
      "taskType": "Filter"
    },
    {
      "destinationField": "company",
      "sourceFields": [
        "company"
      ],
      "taskProperties": {
          "SOURCE_DATA_TYPE": "string"
      },
      "taskType": "Map"
    }
  ]
}
```

### Connection credentials
<a name="API_CreateFlow_Example_5"></a>

This Java example shows credentials associated with a connection. In this case, the example uses OAuth. These credentials are stored in secrets manager after the profile is created.

```
ConnectorProfileCredentials credentials = new ConnectorProfileCredentials().withSalesforce(
        new SalesforceConnectorProfileCredentials().withAccessToken(accessToken)
           .withRefreshToken(refreshToken));
```

### Connection properties
<a name="API_CreateFlow_Example_6"></a>

This Java example shows other properties associated with a connection to Salesforce. 

```
ConnectorProfileProperties properties = new ConnectorProfileProperties().withSalesforce(
                new SalesforceConnectorProfileProperties().withInstanceUrl(instanceUrl));
```

### Connector profile creation
<a name="API_CreateFlow_Example_7"></a>

To create a flow, you must first create a connector profile. This Java example shows information about connecting to Salesforce. 

```
amazonAppflow.createConnectorProfile(new CreateConnectorProfileRequest().withConnectorProfileConfig(
                new ConnectorProfileConfig().withConnectorProfileCredentials(credentials)
                        .withConnectorProfileProperties(properties))
                .withConnectorProfileName(salesforceProfileName)
                .withConnectorType(ConnectorType.Salesforce)
                .withConnectionMode(ConnectionMode.Public));
```

### Source connection properties
<a name="API_CreateFlow_Example_8"></a>

This Java example shows properties for a source connection. `Account` is the object in Salesforce that we want to retrieve. You can find a list of all supported objects by using the `listConnectorEntity` API. The `ConnectorProfileName` is the connector profile, the creation of which is seen in the previous example.

```
  SourceFlowConfig sourceFlowConfig = new SourceFlowConfig().withSourceConnectorProperties(
                new SourceConnectorProperties().withSalesforce(new SalesforceSourceProperties().withObject("Account")))
                .withConnectorType(ConnectorType.Salesforce)
                .withConnectorProfileName(salesforceProfileName);
```

### Destination connection properties
<a name="API_CreateFlow_Example_9"></a>

This Java example shows properties for a destination connection. Note that many AWS connectors such as Amazon S3 don't require a connector profile. Amazon AppFlow accesses S3 buckets through a bucket resource policy, therefore a connector profile isn't needed. 

```
   DestinationFlowConfig destinationFlowConfig = new DestinationFlowConfig().withConnectorType(ConnectorType.S3)
                .withDestinationConnectorProperties(new DestinationConnectorProperties().withS3(
                        new S3DestinationProperties().withBucketName(bucketName).withBucketPrefix("testPrefix")));
```

### Tasks
<a name="API_CreateFlow_Example_10"></a>

 Tasks describe what to do with the data once it has been retrieved, but before it is sent to the destination. Most connectors require a projection task. A projection task describes what fields should be retrieved from the source object. Fields that can be retrieved can be discovered by making a call to the `DescribeConnectorEntity` API. 

```
Task projectionTask = new Task().withTaskType(TaskType.Filter)
                .withConnectorOperator(new ConnectorOperator().withSalesforce(SalesforceConnectorOperator.PROJECTION))
                .withSourceFields("Id", "Name");
```

### Mapping task
<a name="API_CreateFlow_Example_11"></a>

Most flows also require at least one mapping task. Mapping tasks map a source field to a destination field. This Java example shows the mapping between the retrieved field, `Id`, to a new field, `AccountId`.

```
Task createdMappingTask = new Task().withTaskType(TaskType.Map)
                .withConnectorOperator(new ConnectorOperator().withSalesforce(SalesforceConnectorOperator.NO_OP))
                .withSourceFields("Id")
                .withDestinationField("AccountId");
        
        amazonAppflow.createFlow(new CreateFlowRequest().withFlowName(salesforceFlowName)
                .withTriggerConfig(new TriggerConfig().withTriggerType(TriggerType.OnDemand))
                .withSourceFlowConfig(sourceFlowConfig)
                .withDestinationFlowConfigList(destinationFlowConfig)
                .withTasks(projectionTask, idMappingTask, createdMappingTask));
```

### Sample imports
<a name="API_CreateFlow_Example_12"></a>

This Java example shows sample imports.

```
import com.amazonaws.services.appflow.AmazonAppflow;
import com.amazonaws.services.appflow.model.ConnectionMode;
import com.amazonaws.services.appflow.model.ConnectorOperator;
import com.amazonaws.services.appflow.model.ConnectorProfileConfig;
import com.amazonaws.services.appflow.model.ConnectorProfileCredentials;
import com.amazonaws.services.appflow.model.ConnectorProfileProperties;
import com.amazonaws.services.appflow.model.ConnectorType;
import com.amazonaws.services.appflow.model.CreateConnectorProfileRequest;
import com.amazonaws.services.appflow.model.CreateFlowRequest;
import com.amazonaws.services.appflow.model.DeleteConnectorProfileRequest;
import com.amazonaws.services.appflow.model.DeleteFlowRequest;
import com.amazonaws.services.appflow.model.DestinationConnectorProperties;
import com.amazonaws.services.appflow.model.DestinationFlowConfig;
import com.amazonaws.services.appflow.model.S3DestinationProperties;
import com.amazonaws.services.appflow.model.SalesforceConnectorOperator;
import com.amazonaws.services.appflow.model.SalesforceConnectorProfileCredentials;
import com.amazonaws.services.appflow.model.SalesforceConnectorProfileProperties;
import com.amazonaws.services.appflow.model.SalesforceSourceProperties;
import com.amazonaws.services.appflow.model.SourceConnectorProperties;
import com.amazonaws.services.appflow.model.SourceFlowConfig;
import com.amazonaws.services.appflow.model.Task;
import com.amazonaws.services.appflow.model.TaskType;
import com.amazonaws.services.appflow.model.TriggerConfig;
import com.amazonaws.services.appflow.model.TriggerType;
```

## See Also
<a name="API_CreateFlow_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/appflow-2020-08-23/CreateFlow) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/appflow-2020-08-23/CreateFlow) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/appflow-2020-08-23/CreateFlow) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/appflow-2020-08-23/CreateFlow) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/appflow-2020-08-23/CreateFlow) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/appflow-2020-08-23/CreateFlow) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/appflow-2020-08-23/CreateFlow) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/appflow-2020-08-23/CreateFlow) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/appflow-2020-08-23/CreateFlow) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/appflow-2020-08-23/CreateFlow) 

# DeleteConnectorProfile
<a name="API_DeleteConnectorProfile"></a>

 Enables you to delete an existing connector profile. 

## Request Syntax
<a name="API_DeleteConnectorProfile_RequestSyntax"></a>

```
POST /delete-connector-profile HTTP/1.1
Content-type: application/json

{
   "connectorProfileName": "string",
   "forceDelete": boolean
}
```

## URI Request Parameters
<a name="API_DeleteConnectorProfile_RequestParameters"></a>

The request does not use any URI parameters.

## Request Body
<a name="API_DeleteConnectorProfile_RequestBody"></a>

The request accepts the following data in JSON format.

 ** [connectorProfileName](#API_DeleteConnectorProfile_RequestSyntax) **   <a name="appflow-DeleteConnectorProfile-request-connectorProfileName"></a>
 The name of the connector profile. The name is unique for each `ConnectorProfile` in your account.   
Type: String  
Length Constraints: Maximum length of 256.  
Pattern: `[\w/!@#+=.-]+`   
Required: Yes

 ** [forceDelete](#API_DeleteConnectorProfile_RequestSyntax) **   <a name="appflow-DeleteConnectorProfile-request-forceDelete"></a>
 Indicates whether Amazon AppFlow should delete the profile, even if it is currently in use in one or more flows.   
Type: Boolean  
Required: No

## Response Syntax
<a name="API_DeleteConnectorProfile_ResponseSyntax"></a>

```
HTTP/1.1 200
```

## Response Elements
<a name="API_DeleteConnectorProfile_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response with an empty HTTP body.

## Errors
<a name="API_DeleteConnectorProfile_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** ConflictException **   
 There was a conflict when processing the request (for example, a flow with the given name already exists within the account. Check for conflicting resource names and try again.   
HTTP Status Code: 409

 ** InternalServerException **   
 An internal service error occurred during the processing of your request. Try again later.   
HTTP Status Code: 500

 ** ResourceNotFoundException **   
 The resource specified in the request (such as the source or destination connector profile) is not found.   
HTTP Status Code: 404

## Examples
<a name="API_DeleteConnectorProfile_Examples"></a>

### Marketo
<a name="API_DeleteConnectorProfile_Example_1"></a>

This example shows a sample request and response for the `CreateConnectorProfile` API using Marketo. If `forceDelete` is false, and there are flows associated, you will see a message similar to that shown in the third sample.

#### Sample Request
<a name="API_DeleteConnectorProfile_Example_1_Request"></a>

```
{
  "connectorProfileName": "testMarketoProfile",
  "forceDelete": "true"
}
```

#### Sample Response
<a name="API_DeleteConnectorProfile_Example_1_Response"></a>

```
{
  "deleted": true,
  "flowNames": null
}
```

```
{
  "message": "Conflict executing request: Connector profile: testMarketoProfile is associated with one or more flows. If you still want to *delete* it, *then* make *delete* request *with* forceDelete flag *as* true. *Some* of the associated flows are: [myTestFlow1]"
}
```

## See Also
<a name="API_DeleteConnectorProfile_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/appflow-2020-08-23/DeleteConnectorProfile) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/appflow-2020-08-23/DeleteConnectorProfile) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/appflow-2020-08-23/DeleteConnectorProfile) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/appflow-2020-08-23/DeleteConnectorProfile) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/appflow-2020-08-23/DeleteConnectorProfile) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/appflow-2020-08-23/DeleteConnectorProfile) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/appflow-2020-08-23/DeleteConnectorProfile) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/appflow-2020-08-23/DeleteConnectorProfile) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/appflow-2020-08-23/DeleteConnectorProfile) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/appflow-2020-08-23/DeleteConnectorProfile) 

# DeleteFlow
<a name="API_DeleteFlow"></a>

 Enables your application to delete an existing flow. Before deleting the flow, Amazon AppFlow validates the request by checking the flow configuration and status. You can delete flows one at a time. 

## Request Syntax
<a name="API_DeleteFlow_RequestSyntax"></a>

```
POST /delete-flow HTTP/1.1
Content-type: application/json

{
   "flowName": "string",
   "forceDelete": boolean
}
```

## URI Request Parameters
<a name="API_DeleteFlow_RequestParameters"></a>

The request does not use any URI parameters.

## Request Body
<a name="API_DeleteFlow_RequestBody"></a>

The request accepts the following data in JSON format.

 ** [flowName](#API_DeleteFlow_RequestSyntax) **   <a name="appflow-DeleteFlow-request-flowName"></a>
 The specified name of the flow. Spaces are not allowed. Use underscores (\$1) or hyphens (-) only.   
Type: String  
Length Constraints: Maximum length of 256.  
Pattern: `[a-zA-Z0-9][\w!@#.-]+`   
Required: Yes

 ** [forceDelete](#API_DeleteFlow_RequestSyntax) **   <a name="appflow-DeleteFlow-request-forceDelete"></a>
 Indicates whether Amazon AppFlow should delete the flow, even if it is currently in use.   
Type: Boolean  
Required: No

## Response Syntax
<a name="API_DeleteFlow_ResponseSyntax"></a>

```
HTTP/1.1 200
```

## Response Elements
<a name="API_DeleteFlow_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response with an empty HTTP body.

## Errors
<a name="API_DeleteFlow_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** ConflictException **   
 There was a conflict when processing the request (for example, a flow with the given name already exists within the account. Check for conflicting resource names and try again.   
HTTP Status Code: 409

 ** InternalServerException **   
 An internal service error occurred during the processing of your request. Try again later.   
HTTP Status Code: 500

 ** ResourceNotFoundException **   
 The resource specified in the request (such as the source or destination connector profile) is not found.   
HTTP Status Code: 404

## Examples
<a name="API_DeleteFlow_Examples"></a>

### An active scheduled flow with forceDelete false
<a name="API_DeleteFlow_Example_1"></a>

This example shows an active scheduled flow with `forceDelete` false. The result is that a conflict exception is thrown.

#### Sample Request
<a name="API_DeleteFlow_Example_1_Request"></a>

```
{
  "flowName": "flowName_value"
}
```

#### Sample Response
<a name="API_DeleteFlow_Example_1_Response"></a>

```
{
  "message": "Conflict executing request: Flow is in active state, please set forceDelete to true or deactivate the flow: flowName_value"
}
```

### An active scheduled flow with forceDelete true
<a name="API_DeleteFlow_Example_2"></a>

This example shows an active scheduled flow with `forceDelete` true. The result is that the flow is deleted successfully.

#### Sample Request
<a name="API_DeleteFlow_Example_2_Request"></a>

```
{
  "flowName": "flowName_value",
  "forceDelete": true
}
```

#### Sample Response
<a name="API_DeleteFlow_Example_2_Response"></a>

```
{}
```

## See Also
<a name="API_DeleteFlow_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/appflow-2020-08-23/DeleteFlow) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/appflow-2020-08-23/DeleteFlow) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/appflow-2020-08-23/DeleteFlow) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/appflow-2020-08-23/DeleteFlow) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/appflow-2020-08-23/DeleteFlow) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/appflow-2020-08-23/DeleteFlow) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/appflow-2020-08-23/DeleteFlow) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/appflow-2020-08-23/DeleteFlow) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/appflow-2020-08-23/DeleteFlow) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/appflow-2020-08-23/DeleteFlow) 

# DescribeConnector
<a name="API_DescribeConnector"></a>

Describes the given custom connector registered in your AWS account. This API can be used for custom connectors that are registered in your account and also for Amazon authored connectors.

## Request Syntax
<a name="API_DescribeConnector_RequestSyntax"></a>

```
POST /describe-connector HTTP/1.1
Content-type: application/json

{
   "connectorLabel": "string",
   "connectorType": "string"
}
```

## URI Request Parameters
<a name="API_DescribeConnector_RequestParameters"></a>

The request does not use any URI parameters.

## Request Body
<a name="API_DescribeConnector_RequestBody"></a>

The request accepts the following data in JSON format.

 ** [connectorLabel](#API_DescribeConnector_RequestSyntax) **   <a name="appflow-DescribeConnector-request-connectorLabel"></a>
The label of the connector. The label is unique for each `ConnectorRegistration` in your AWS account. Only needed if calling for CUSTOMCONNECTOR connector type/.  
Type: String  
Length Constraints: Maximum length of 256.  
Pattern: `[a-zA-Z0-9][\w!@#.-]+`   
Required: No

 ** [connectorType](#API_DescribeConnector_RequestSyntax) **   <a name="appflow-DescribeConnector-request-connectorType"></a>
The connector type, such as CUSTOMCONNECTOR, Saleforce, Marketo. Please choose CUSTOMCONNECTOR for Lambda based custom connectors.  
Type: String  
Valid Values: `Salesforce | Singular | Slack | Redshift | S3 | Marketo | Googleanalytics | Zendesk | Servicenow | Datadog | Trendmicro | Snowflake | Dynatrace | Infornexus | Amplitude | Veeva | EventBridge | LookoutMetrics | Upsolver | Honeycode | CustomerProfiles | SAPOData | CustomConnector | Pardot`   
Required: Yes

## Response Syntax
<a name="API_DescribeConnector_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "connectorConfiguration": { 
      "authenticationConfig": { 
         "customAuthConfigs": [ 
            { 
               "authParameters": [ 
                  { 
                     "connectorSuppliedValues": [ "string" ],
                     "description": "string",
                     "isRequired": boolean,
                     "isSensitiveField": boolean,
                     "key": "string",
                     "label": "string"
                  }
               ],
               "customAuthenticationType": "string"
            }
         ],
         "isApiKeyAuthSupported": boolean,
         "isBasicAuthSupported": boolean,
         "isCustomAuthSupported": boolean,
         "isOAuth2Supported": boolean,
         "oAuth2Defaults": { 
            "authCodeUrls": [ "string" ],
            "oauth2CustomProperties": [ 
               { 
                  "connectorSuppliedValues": [ "string" ],
                  "description": "string",
                  "isRequired": boolean,
                  "isSensitiveField": boolean,
                  "key": "string",
                  "label": "string",
                  "type": "string"
               }
            ],
            "oauth2GrantTypesSupported": [ "string" ],
            "oauthScopes": [ "string" ],
            "tokenUrls": [ "string" ]
         }
      },
      "canUseAsDestination": boolean,
      "canUseAsSource": boolean,
      "connectorArn": "string",
      "connectorDescription": "string",
      "connectorLabel": "string",
      "connectorMetadata": { 
         "Amplitude": { 
         },
         "CustomerProfiles": { 
         },
         "Datadog": { 
         },
         "Dynatrace": { 
         },
         "EventBridge": { 
         },
         "GoogleAnalytics": { 
            "oAuthScopes": [ "string" ]
         },
         "Honeycode": { 
            "oAuthScopes": [ "string" ]
         },
         "InforNexus": { 
         },
         "Marketo": { 
         },
         "Pardot": { 
         },
         "Redshift": { 
         },
         "S3": { 
         },
         "Salesforce": { 
            "dataTransferApis": [ "string" ],
            "oauth2GrantTypesSupported": [ "string" ],
            "oAuthScopes": [ "string" ]
         },
         "SAPOData": { 
         },
         "ServiceNow": { 
         },
         "Singular": { 
         },
         "Slack": { 
            "oAuthScopes": [ "string" ]
         },
         "Snowflake": { 
            "supportedRegions": [ "string" ]
         },
         "Trendmicro": { 
         },
         "Upsolver": { 
         },
         "Veeva": { 
         },
         "Zendesk": { 
            "oAuthScopes": [ "string" ]
         }
      },
      "connectorModes": [ "string" ],
      "connectorName": "string",
      "connectorOwner": "string",
      "connectorProvisioningConfig": { 
         "lambda": { 
            "lambdaArn": "string"
         }
      },
      "connectorProvisioningType": "string",
      "connectorRuntimeSettings": [ 
         { 
            "connectorSuppliedValueOptions": [ "string" ],
            "dataType": "string",
            "description": "string",
            "isRequired": boolean,
            "key": "string",
            "label": "string",
            "scope": "string"
         }
      ],
      "connectorType": "string",
      "connectorVersion": "string",
      "isPrivateLinkEnabled": boolean,
      "isPrivateLinkEndpointUrlRequired": boolean,
      "logoURL": "string",
      "registeredAt": number,
      "registeredBy": "string",
      "supportedApiVersions": [ "string" ],
      "supportedDataTransferApis": [ 
         { 
            "Name": "string",
            "Type": "string"
         }
      ],
      "supportedDataTransferTypes": [ "string" ],
      "supportedDestinationConnectors": [ "string" ],
      "supportedOperators": [ "string" ],
      "supportedSchedulingFrequencies": [ "string" ],
      "supportedTriggerTypes": [ "string" ],
      "supportedWriteOperations": [ "string" ]
   }
}
```

## Response Elements
<a name="API_DescribeConnector_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [connectorConfiguration](#API_DescribeConnector_ResponseSyntax) **   <a name="appflow-DescribeConnector-response-connectorConfiguration"></a>
Configuration info of all the connectors that the user requested.  
Type: [ConnectorConfiguration](API_ConnectorConfiguration.md) object

## Errors
<a name="API_DescribeConnector_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** InternalServerException **   
 An internal service error occurred during the processing of your request. Try again later.   
HTTP Status Code: 500

 ** ResourceNotFoundException **   
 The resource specified in the request (such as the source or destination connector profile) is not found.   
HTTP Status Code: 404

 ** ValidationException **   
 The request has invalid or missing parameters.   
HTTP Status Code: 400

## Examples
<a name="API_DescribeConnector_Examples"></a>

### Describing the given connector
<a name="API_DescribeConnector_Example_1"></a>

This example shows a sample request for the `DescribeConnector` API and a sample response.

#### Sample Request
<a name="API_DescribeConnector_Example_1_Request"></a>

```
{
  "connectorType": "connectorType",
  "connectorLabel": "connectorLabel"
}
```

#### Sample Response
<a name="API_DescribeConnector_Example_1_Response"></a>

```
{
  "connectorConfiguration":
  {
    "authenticationConfig": null,
    "canUseAsDestination": true,
    "canUseAsSource": true,
    "connectorArn": null,
    "connectorDescription": "Salesforce",
    "connectorLabel": null,
    "connectorMetadata":
    {
      "Amplitude": null,
      "AppIntegrations": null,
      "CustomerProfiles": null,
      "Datadog": null,
      "Dynatrace": null,
      "EventBridge": null,
      "GoogleAnalytics": null,
      "Honeycode": null,
      "InforNexus": null,
      "Locke": null,
      "Marketo": null,
      "Pardot": null,
      "Redshift": null,
      "S3": null,
      "SAPOData": null,
      "Salesforce":
      {
        "oAuthScopes":
        [
          "api",
          "refresh_token",
          "id"
        ]
      },
      "ServiceNow": null,
      "Singular": null,
      "Slack": null,
      "Snowflake": null,
      "Trendmicro": null,
      "Upsolver": null,
      "Veeva": null,
      "Zendesk": null
    },
    "connectorModes": null,
    "connectorName": null,
    "connectorOwner": null,
    "connectorProvisioningConfig": null,
    "connectorProvisioningType": null,
    "connectorRuntimeSettings": null,
    "connectorType": "SALESFORCE",
    "connectorVersion": null,
    "isPrivateLinkEnabled": true,
    "isPrivateLinkEndpointUrlRequired": false,
    "logoURL": "insert-logo-here",
    "registeredAt": null,
    "registeredBy": null,
    "supportedApiVersions": null,
    "supportedDestinationConnectors":
    [
      "S3",
      "Snowflake",
      "Redshift",
      "Salesforce",
      "EventBridge",
      "LookoutMetrics",
      "Locke",
      "Honeycode",
      "Upsolver",
      "CustomerProfiles",
      "Zendesk",
      "Marketo",
      "CustomConnector"
    ],
    "supportedOperators": null,
    "supportedSchedulingFrequencies":
    [
      "BYMINUTE",
      "HOURLY",
      "DAILY",
      "WEEKLY",
      "MONTHLY",
      "ONCE"
    ],
    "supportedTriggerTypes":
    [
      "Scheduled",
      "OnDemand",
      "Event"
    ],
    "supportedWriteOperations": null
  }
}
```

## See Also
<a name="API_DescribeConnector_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/appflow-2020-08-23/DescribeConnector) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/appflow-2020-08-23/DescribeConnector) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/appflow-2020-08-23/DescribeConnector) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/appflow-2020-08-23/DescribeConnector) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/appflow-2020-08-23/DescribeConnector) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/appflow-2020-08-23/DescribeConnector) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/appflow-2020-08-23/DescribeConnector) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/appflow-2020-08-23/DescribeConnector) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/appflow-2020-08-23/DescribeConnector) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/appflow-2020-08-23/DescribeConnector) 

# DescribeConnectorEntity
<a name="API_DescribeConnectorEntity"></a>

 Provides details regarding the entity used with the connector, with a description of the data model for each field in that entity. 

## Request Syntax
<a name="API_DescribeConnectorEntity_RequestSyntax"></a>

```
POST /describe-connector-entity HTTP/1.1
Content-type: application/json

{
   "apiVersion": "string",
   "connectorEntityName": "string",
   "connectorProfileName": "string",
   "connectorType": "string"
}
```

## URI Request Parameters
<a name="API_DescribeConnectorEntity_RequestParameters"></a>

The request does not use any URI parameters.

## Request Body
<a name="API_DescribeConnectorEntity_RequestBody"></a>

The request accepts the following data in JSON format.

 ** [apiVersion](#API_DescribeConnectorEntity_RequestSyntax) **   <a name="appflow-DescribeConnectorEntity-request-apiVersion"></a>
The version of the API that's used by the connector.  
Type: String  
Length Constraints: Maximum length of 256.  
Pattern: `\S+`   
Required: No

 ** [connectorEntityName](#API_DescribeConnectorEntity_RequestSyntax) **   <a name="appflow-DescribeConnectorEntity-request-connectorEntityName"></a>
 The entity name for that connector.   
Type: String  
Length Constraints: Maximum length of 1024.  
Pattern: `\S+`   
Required: Yes

 ** [connectorProfileName](#API_DescribeConnectorEntity_RequestSyntax) **   <a name="appflow-DescribeConnectorEntity-request-connectorProfileName"></a>
 The name of the connector profile. The name is unique for each `ConnectorProfile` in the AWS account.   
Type: String  
Length Constraints: Maximum length of 256.  
Pattern: `[\w/!@#+=.-]+`   
Required: No

 ** [connectorType](#API_DescribeConnectorEntity_RequestSyntax) **   <a name="appflow-DescribeConnectorEntity-request-connectorType"></a>
 The type of connector application, such as Salesforce, Amplitude, and so on.   
Type: String  
Valid Values: `Salesforce | Singular | Slack | Redshift | S3 | Marketo | Googleanalytics | Zendesk | Servicenow | Datadog | Trendmicro | Snowflake | Dynatrace | Infornexus | Amplitude | Veeva | EventBridge | LookoutMetrics | Upsolver | Honeycode | CustomerProfiles | SAPOData | CustomConnector | Pardot`   
Required: No

## Response Syntax
<a name="API_DescribeConnectorEntity_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "connectorEntityFields": [ 
      { 
         "customProperties": { 
            "string" : "string" 
         },
         "defaultValue": "string",
         "description": "string",
         "destinationProperties": { 
            "isCreatable": boolean,
            "isDefaultedOnCreate": boolean,
            "isNullable": boolean,
            "isUpdatable": boolean,
            "isUpsertable": boolean,
            "supportedWriteOperations": [ "string" ]
         },
         "identifier": "string",
         "isDeprecated": boolean,
         "isPrimaryKey": boolean,
         "label": "string",
         "parentIdentifier": "string",
         "sourceProperties": { 
            "isQueryable": boolean,
            "isRetrievable": boolean,
            "isTimestampFieldForIncrementalQueries": boolean
         },
         "supportedFieldTypeDetails": { 
            "v1": { 
               "fieldLengthRange": { 
                  "maximum": number,
                  "minimum": number
               },
               "fieldType": "string",
               "fieldValueRange": { 
                  "maximum": number,
                  "minimum": number
               },
               "filterOperators": [ "string" ],
               "supportedDateFormat": "string",
               "supportedValues": [ "string" ],
               "valueRegexPattern": "string"
            }
         }
      }
   ]
}
```

## Response Elements
<a name="API_DescribeConnectorEntity_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [connectorEntityFields](#API_DescribeConnectorEntity_ResponseSyntax) **   <a name="appflow-DescribeConnectorEntity-response-connectorEntityFields"></a>
 Describes the fields for that connector entity. For example, for an *account* entity, the fields would be *account name*, *account ID*, and so on.   
Type: Array of [ConnectorEntityField](API_ConnectorEntityField.md) objects

## Errors
<a name="API_DescribeConnectorEntity_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** ConnectorAuthenticationException **   
 An error occurred when authenticating with the connector endpoint.   
HTTP Status Code: 401

 ** ConnectorServerException **   
 An error occurred when retrieving data from the connector endpoint.   
HTTP Status Code: 400

 ** InternalServerException **   
 An internal service error occurred during the processing of your request. Try again later.   
HTTP Status Code: 500

 ** ResourceNotFoundException **   
 The resource specified in the request (such as the source or destination connector profile) is not found.   
HTTP Status Code: 404

 ** ValidationException **   
 The request has invalid or missing parameters.   
HTTP Status Code: 400

## Examples
<a name="API_DescribeConnectorEntity_Examples"></a>

### DescribeConnectorEntity example
<a name="API_DescribeConnectorEntity_Example_1"></a>

This example shows a sample request and response for the `DescribeConnectorEntity` API 

#### Sample Request
<a name="API_DescribeConnectorEntity_Example_1_Request"></a>

```
{
  "connectorEntityName": "tickets",
  "connectorProfileName": "connector_profile_name",
  "connectorType": "Zendesk"
}
```

#### Sample Response
<a name="API_DescribeConnectorEntity_Example_1_Response"></a>

```
{
  "connectorEntityFields": [
    {
      "description": "Account ID",
      "destinationProperties": {
        "isCreatable": false,
        "isNullable": false,
        "isUpdatable": false,
        "isUpsertable": false,
        "supportedWriteOperations": [
          "UPDATE",
          "UPSERT"
        ]
      },
      "identifier": "Id",
      "label": "Account ID",
      "sourceProperties": {
        "isQueryable": true,
        "isRetrievable": true
      },
      "supportedFieldTypeDetails": {
        "v1": {
          "fieldType": "id",
          "filterOperators": [
            "EQUAL_TO"
          ],
          "supportedValues": []
        }
      }
    },
    {
      "description": "Deleted",
      "destinationProperties": {
        "isCreatable": false,
        "isNullable": false,
        "isUpdatable": false,
        "isUpsertable": false,
        "supportedWriteOperations": []
      },
      "identifier": "IsDeleted",
      "label": "Deleted",
      "sourceProperties": {
        "isQueryable": true,
        "isRetrievable": true
      },
      "supportedFieldTypeDetails": {
        "v1": {
          "fieldType": "boolean",
          "filterOperators": [
            "EQUAL_TO"
          ],
          "supportedValues": [
            "true",
            "false"
          ]
        }
      }
    },
    {
      "description": "Master Record ID",
      "destinationProperties": {
        "isCreatable": false,
        "isNullable": true,
        "isUpdatable": false,
        "isUpsertable": false,
        "supportedWriteOperations": []
      },
      "identifier": "MasterRecordId",
      "label": "Master Record ID",
      "sourceProperties": {
        "isQueryable": true,
        "isRetrievable": true
      },
      "supportedFieldTypeDetails": {
        "v1": {
          "fieldType": "reference",
          "filterOperators": [
            "EQUAL_TO"
          ],
          "supportedValues": []
        }
      }
    },
    {
      "description": "Account Name",
      "destinationProperties": {
        "isCreatable": true,
        "isNullable": false,
        "isUpdatable": true,
        "isUpsertable": true,
        "supportedWriteOperations": []
      },
      "identifier": "Name",
      "label": "Account Name",
      "sourceProperties": {
        "isQueryable": true,
        "isRetrievable": true
      },
      "supportedFieldTypeDetails": {
        "v1": {
          "fieldType": "string",
          "filterOperators": [
            "CONTAINS",
            "EQUAL_TO",
            "NOT_EQUAL_TO"
          ],
          "supportedValues": []
        }
      }
    },
    {
      "description": "Account Type",
      "destinationProperties": {
        "isCreatable": true,
        "isNullable": true,
        "isUpdatable": true,
        "isUpsertable": true,
        "supportedWriteOperations": []
      },
      "identifier": "Type",
      "label": "Account Type",
      "sourceProperties": {
        "isQueryable": true,
        "isRetrievable": true
      },
      "supportedFieldTypeDetails": {
        "v1": {
          "fieldType": "picklist",
          "filterOperators": [
            "EQUAL_TO"
          ],
          "supportedValues": []
        }
      }
    },
    {
      "description": "Parent Account ID",
      "destinationProperties": {
        "isCreatable": true,
        "isNullable": true,
        "isUpdatable": true,
        "isUpsertable": true,
        "supportedWriteOperations": []
      },
      "identifier": "ParentId",
      "label": "Parent Account ID",
      "sourceProperties": {
        "isQueryable": true,
        "isRetrievable": true
      },
      "supportedFieldTypeDetails": {
        "v1": {
          "fieldType": "reference",
          "filterOperators": [
            "EQUAL_TO"
          ],
          "supportedValues": []
        }
      }
    },
    {
      "description": "Billing Street",
      "destinationProperties": {
        "isCreatable": true,
        "isNullable": true,
        "isUpdatable": true,
        "isUpsertable": true,
        "supportedWriteOperations": []
      },
      "identifier": "BillingStreet",
      "label": "Billing Street",
      "sourceProperties": {
        "isQueryable": true,
        "isRetrievable": true
      },
      "supportedFieldTypeDetails": {
        "v1": {
          "fieldType": "textarea",
          "filterOperators": [
            "EQUAL_TO"
          ],
          "supportedValues": []
        }
      }
    },
    {
      "description": "Billing City",
      "destinationProperties": {
        "isCreatable": true,
        "isNullable": true,
        "isUpdatable": true,
        "isUpsertable": true,
        "supportedWriteOperations": []
      },
      "identifier": "BillingCity",
      "label": "Billing City",
      "sourceProperties": {
        "isQueryable": true,
        "isRetrievable": true
      },
      "supportedFieldTypeDetails": {
        "v1": {
          "fieldType": "string",
          "filterOperators": [
            "CONTAINS",
            "EQUAL_TO",
            "NOT_EQUAL_TO"
          ],
          "supportedValues": []
        }
      }
    },
    {
      "description": "Billing State/Province",
      "destinationProperties": {
        "isCreatable": true,
        "isNullable": true,
        "isUpdatable": true,
        "isUpsertable": true,
        "supportedWriteOperations": []
      },
      "identifier": "BillingState",
      "label": "Billing State/Province",
      "sourceProperties": {
        "isQueryable": true,
        "isRetrievable": true
      },
      "supportedFieldTypeDetails": {
        "v1": {
          "fieldType": "string",
          "filterOperators": [
            "CONTAINS",
            "EQUAL_TO",
            "NOT_EQUAL_TO"
          ],
          "supportedValues": []
        }
      }
    },
    {
      "description": "Billing Zip/Postal Code",
      "destinationProperties": {
        "isCreatable": true,
        "isNullable": true,
        "isUpdatable": true,
        "isUpsertable": true,
        "supportedWriteOperations": []
      },
      "identifier": "BillingPostalCode",
      "label": "Billing Zip/Postal Code",
      "sourceProperties": {
        "isQueryable": true,
        "isRetrievable": true
      },
      "supportedFieldTypeDetails": {
        "v1": {
          "fieldType": "string",
          "filterOperators": [
            "CONTAINS",
            "EQUAL_TO",
            "NOT_EQUAL_TO"
          ],
          "supportedValues": []
        }
      }
    },
    {
      "description": "Billing Country",
      "destinationProperties": {
        "isCreatable": true,
        "isNullable": true,
        "isUpdatable": true,
        "isUpsertable": true,
        "supportedWriteOperations": []
      },
      "identifier": "BillingCountry",
      "label": "Billing Country",
      "sourceProperties": {
        "isQueryable": true,
        "isRetrievable": true
      },
      "supportedFieldTypeDetails": {
        "v1": {
          "fieldType": "string",
          "filterOperators": [
            "CONTAINS",
            "EQUAL_TO",
            "NOT_EQUAL_TO"
          ],
          "supportedValues": []
        }
      }
    },
    {
      "description": "Billing Latitude",
      "destinationProperties": {
        "isCreatable": true,
        "isNullable": true,
        "isUpdatable": true,
        "isUpsertable": true,
        "supportedWriteOperations": []
      },
      "identifier": "BillingLatitude",
      "label": "Billing Latitude",
      "sourceProperties": {
        "isQueryable": true,
        "isRetrievable": true
      },
      "supportedFieldTypeDetails": {
        "v1": {
          "fieldType": "double",
          "filterOperators": [
            "NOT_EQUAL_TO",
            "EQUAL_TO",
            "LESS_THAN",
            "LESS_THAN_OR_EQUAL_TO",
            "GREATER_THAN",
            "GREATER_THAN_OR_EQUAL_TO"
          ],
          "supportedValues": []
        }
      }
    },
    {
      "description": "Billing Longitude",
      "destinationProperties": {
        "isCreatable": true,
        "isNullable": true,
        "isUpdatable": true,
        "isUpsertable": true,
        "supportedWriteOperations": []
      },
      "identifier": "BillingLongitude",
      "label": "Billing Longitude",
      "sourceProperties": {
        "isQueryable": true,
        "isRetrievable": true
      },
      "supportedFieldTypeDetails": {
        "v1": {
          "fieldType": "double",
          "filterOperators": [
            "NOT_EQUAL_TO",
            "EQUAL_TO",
            "LESS_THAN",
            "LESS_THAN_OR_EQUAL_TO",
            "GREATER_THAN",
            "GREATER_THAN_OR_EQUAL_TO"
          ],
          "supportedValues": []
        }
      }
    },
    {
      "description": "Billing Geocode Accuracy",
      "destinationProperties": {
        "isCreatable": true,
        "isNullable": true,
        "isUpdatable": true,
        "isUpsertable": true,
        "supportedWriteOperations": []
      },
      "identifier": "BillingGeocodeAccuracy",
      "label": "Billing Geocode Accuracy",
      "sourceProperties": {
        "isQueryable": true,
        "isRetrievable": true
      },
      "supportedFieldTypeDetails": {
        "v1": {
          "fieldType": "picklist",
          "filterOperators": [
            "EQUAL_TO"
          ],
          "supportedValues": []
        }
      }
    },
    {
      "description": "Billing Address",
      "destinationProperties": {
        "isCreatable": false,
        "isNullable": true,
        "isUpdatable": false,
        "isUpsertable": false,
        "supportedWriteOperations": []
      },
      "identifier": "BillingAddress",
      "label": "Billing Address",
      "sourceProperties": {
        "isQueryable": true,
        "isRetrievable": true
      },
      "supportedFieldTypeDetails": {
        "v1": {
          "fieldType": "address",
          "filterOperators": [
            "EQUAL_TO"
          ],
          "supportedValues": []
        }
      }
    },
    {
      "description": "Shipping Street",
      "destinationProperties": {
        "isCreatable": true,
        "isNullable": true,
        "isUpdatable": true,
        "isUpsertable": true,
        "supportedWriteOperations": []
      },
      "identifier": "ShippingStreet",
      "label": "Shipping Street",
      "sourceProperties": {
        "isQueryable": true,
        "isRetrievable": true
      },
      "supportedFieldTypeDetails": {
        "v1": {
          "fieldType": "textarea",
          "filterOperators": [
            "EQUAL_TO"
          ],
          "supportedValues": []
        }
      }
    },
    {
      "description": "Shipping City",
      "destinationProperties": {
        "isCreatable": true,
        "isNullable": true,
        "isUpdatable": true,
        "isUpsertable": true,
        "supportedWriteOperations": []
      },
      "identifier": "ShippingCity",
      "label": "Shipping City",
      "sourceProperties": {
        "isQueryable": true,
        "isRetrievable": true
      },
      "supportedFieldTypeDetails": {
        "v1": {
          "fieldType": "string",
          "filterOperators": [
            "CONTAINS",
            "EQUAL_TO",
            "NOT_EQUAL_TO"
          ],
          "supportedValues": []
        }
      }
    },
    {
      "description": "Shipping State/Province",
      "destinationProperties": {
        "isCreatable": true,
        "isNullable": true,
        "isUpdatable": true,
        "isUpsertable": true,
        "supportedWriteOperations": []
      },
      "identifier": "ShippingState",
      "label": "Shipping State/Province",
      "sourceProperties": {
        "isQueryable": true,
        "isRetrievable": true
      },
      "supportedFieldTypeDetails": {
        "v1": {
          "fieldType": "string",
          "filterOperators": [
            "CONTAINS",
            "EQUAL_TO",
            "NOT_EQUAL_TO"
          ],
          "supportedValues": []
        }
      }
    },
    {
      "description": "Shipping Zip/Postal Code",
      "destinationProperties": {
        "isCreatable": true,
        "isNullable": true,
        "isUpdatable": true,
        "isUpsertable": true,
        "supportedWriteOperations": []
      },
      "identifier": "ShippingPostalCode",
      "label": "Shipping Zip/Postal Code",
      "sourceProperties": {
        "isQueryable": true,
        "isRetrievable": true
      },
      "supportedFieldTypeDetails": {
        "v1": {
          "fieldType": "string",
          "filterOperators": [
            "CONTAINS",
            "EQUAL_TO",
            "NOT_EQUAL_TO"
          ],
          "supportedValues": []
        }
      }
    },
    {
      "description": "Shipping Country",
      "destinationProperties": {
        "isCreatable": true,
        "isNullable": true,
        "isUpdatable": true,
        "isUpsertable": true,
        "supportedWriteOperations": []
      },
      "identifier": "ShippingCountry",
      "label": "Shipping Country",
      "sourceProperties": {
        "isQueryable": true,
        "isRetrievable": true
      },
      "supportedFieldTypeDetails": {
        "v1": {
          "fieldType": "string",
          "filterOperators": [
            "CONTAINS",
            "EQUAL_TO",
            "NOT_EQUAL_TO"
          ],
          "supportedValues": []
        }
      }
    },
    {
      "description": "Shipping Latitude",
      "destinationProperties": {
        "isCreatable": true,
        "isNullable": true,
        "isUpdatable": true,
        "isUpsertable": true,
        "supportedWriteOperations": []
      },
      "identifier": "ShippingLatitude",
      "label": "Shipping Latitude",
      "sourceProperties": {
        "isQueryable": true,
        "isRetrievable": true
      },
      "supportedFieldTypeDetails": {
        "v1": {
          "fieldType": "double",
          "filterOperators": [
            "NOT_EQUAL_TO",
            "EQUAL_TO",
            "LESS_THAN",
            "LESS_THAN_OR_EQUAL_TO",
            "GREATER_THAN",
            "GREATER_THAN_OR_EQUAL_TO"
          ],
          "supportedValues": []
        }
      }
    },
    {
      "description": "Shipping Longitude",
      "destinationProperties": {
        "isCreatable": true,
        "isNullable": true,
        "isUpdatable": true,
        "isUpsertable": true,
        "supportedWriteOperations": []
      },
      "identifier": "ShippingLongitude",
      "label": "Shipping Longitude",
      "sourceProperties": {
        "isQueryable": true,
        "isRetrievable": true
      },
      "supportedFieldTypeDetails": {
        "v1": {
          "fieldType": "double",
          "filterOperators": [
            "NOT_EQUAL_TO",
            "EQUAL_TO",
            "LESS_THAN",
            "LESS_THAN_OR_EQUAL_TO",
            "GREATER_THAN",
            "GREATER_THAN_OR_EQUAL_TO"
          ],
          "supportedValues": []
        }
      }
    },
    {
      "description": "Shipping Geocode Accuracy",
      "destinationProperties": {
        "isCreatable": true,
        "isNullable": true,
        "isUpdatable": true,
        "isUpsertable": true,
        "supportedWriteOperations": []
      },
      "identifier": "ShippingGeocodeAccuracy",
      "label": "Shipping Geocode Accuracy",
      "sourceProperties": {
        "isQueryable": true,
        "isRetrievable": true
      },
      "supportedFieldTypeDetails": {
        "v1": {
          "fieldType": "picklist",
          "filterOperators": [
            "EQUAL_TO"
          ],
          "supportedValues": []
        }
      }
    },
    {
      "description": "Shipping Address",
      "destinationProperties": {
        "isCreatable": false,
        "isNullable": true,
        "isUpdatable": false,
        "isUpsertable": false,
        "supportedWriteOperations": []
      },
      "identifier": "ShippingAddress",
      "label": "Shipping Address",
      "sourceProperties": {
        "isQueryable": true,
        "isRetrievable": true
      },
      "supportedFieldTypeDetails": {
        "v1": {
          "fieldType": "address",
          "filterOperators": [
            "EQUAL_TO"
          ],
          "supportedValues": []
        }
      }
    },
    {
      "description": "Account Phone",
      "destinationProperties": {
        "isCreatable": true,
        "isNullable": true,
        "isUpdatable": true,
        "isUpsertable": true,
        "supportedWriteOperations": []
      },
[...]
